LinearProg=function(n,m,thetas,distances,G,typeDistance,zeta){

 library(glpkAPI)

		lp=select_func(G, distances,m,zeta,thetas)

		solveInteriorGLPK(lp)
		lp
	
	return(lp)
}
	
	
	


select_func=function(G,distances,m,zeta,thetas){
	
	if(G=='max'){
		list_coef_fineq=MaxGO(m,zeta,thetas)
	}
	if(G=='min'){
		list_coef_fineq=MinGO(distances,m,zeta,thetas)
	}
	if(G=='sim'){
		list_coef_fineq=SimAB(m,zeta,thetas)
	}
		return(list_coef_fineq)
	
}


MaxGO=function(m,zeta,thetas){
	
	obj=rep(0,m)
	obj[1]=1/zeta[1]
	obj[2]=-1/zeta[2]
	
	lp <- initProbGLPK()
		
	nrows <- m
    ncols <- m
    
    ne <- 2*m
    
	ia <- c(1,m,1,rep(2:(m-1),each=2),m)
	ja <- rep(1:m,each=2)
	ar=c(1/zeta[1])
	ar=c(ar,-1/zeta[1])
	
	for (i in 2:(m-1)){
		ar=c(ar,-1/zeta[i])
		ar=c(ar,1/zeta[i])
	}
	ar=c(ar,-1/zeta[m])
	ar=c(ar,(2-exp(-min(thetas)))/zeta[m])

	rlower=runif(m,0.0001,0.0002)
	rupper=rep(100,m)
	
	clower=rep(0,m)
	cupper=50*zeta

	setObjDirGLPK(lp, GLP_MAX)
	
	addRowsGLPK(lp,nrows)
	addColsGLPK(lp,ncols)
	
	setColsBndsObjCoefsGLPK(lp,c(1:ncols),clower,cupper,obj)
	setRowsBndsGLPK(lp,c(1:nrows),rlower,rupper)
	
	loadMatrixGLPK(lp,ne,ia,ja,ar)
				
	return(lp)
}

MinGO=function(distances,m,zeta,thetas){
	
	obj=rep(0,m)
	obj[1]=1/zeta[1]
	for (rest_ind in 2:m){
			obj[rest_ind]=-exp(-max(thetas[rest_ind,])*(distances[rest_ind]+1))/((m-1)*zeta[rest_ind])
	}

	lp <- initProbGLPK()
		
	nrows <- m
    ncols <- m
    
    ne <- 2*m
    
	ia <- c(1,m,1,rep(2:(m-1),each=2),m)
	ja <- rep(1:m,each=2)
	ar=c(1/zeta[1])
	ar=c(ar,-1/zeta[1])
	for (i in 2:(m-1)){
		ar=c(ar,-1/zeta[i])
		ar=c(ar,1/zeta[i])
	}
	ar=c(ar,-1/zeta[m])
	ar=c(ar,(2-exp(-min(thetas)))/zeta[m])

	rlower=runif(m,0.0001,0.0002)
	rupper=rep(100,m)
	
	clower=rep(0,m)
	cupper=50*zeta

	setObjDirGLPK(lp, GLP_MIN)
	
	addRowsGLPK(lp,nrows)
	addColsGLPK(lp,ncols)
	
	setColsBndsObjCoefsGLPK(lp,c(1:ncols),clower,cupper,obj)
	setRowsBndsGLPK(lp,c(1:nrows),rlower,rupper)
	
	loadMatrixGLPK(lp,ne,ia,ja,ar)
				
	return(lp)

}


SimAB=function(m,zeta,thetas){
	
	obj=rep(0,m)
	obj[1]=1/zeta[1]
	obj[m]=-1/zeta[m]

	lp <- initProbGLPK()
		
	nrows <- m
    ncols <- m
    
    ne <- 2*m
    
	ia <- c(1,m,1,rep(2:(m-1),each=2),m)
	ja <- rep(1:m,each=2)
	ar=c(1/zeta[1])
	ar=c(ar,-1/zeta[1])
	for (i in 2:(m-1)){
		ar=c(ar,-1/zeta[i])
		ar=c(ar,1/zeta[i])
	}
	ar=c(ar,-1/zeta[m])
	ar=c(ar,(2-exp(-min(thetas)))/zeta[m])


	rlower=runif(m,0.0001,0.0002)
	rupper=rep(100,m)
	
	clower=rep(0,m)
	cupper=50*zeta

	setObjDirGLPK(lp, GLP_MIN)
	
	addRowsGLPK(lp,nrows)
	addColsGLPK(lp,ncols)
	
	setColsBndsObjCoefsGLPK(lp,c(1:ncols),clower,cupper,obj)
	setRowsBndsGLPK(lp,c(1:nrows),rlower,rupper)
	
	loadMatrixGLPK(lp,ne,ia,ja,ar)
				
	return(lp)
}
